import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class BatchStoredProcedureUsingJDBCCallableStatement {

	public static void main(String[] args) {

		// variables
		Connection connection = null;
		CallableStatement callableStatement = null;

		// Step 1: Loading or registering MySQL JDBC driver class
		try {
			Class.forName("com.mysql.jdbc.Driver");
		}
		catch(ClassNotFoundException cnfex) {
			System.out.println("Problem in loading or registering MySQL JDBC driver");
			cnfex.printStackTrace();
		}

		// Step 2: Opening database connection
		try {

			// Step 2.A: Create and get connection using DriverManager class
			connection = DriverManager.getConnection("jdbc:mysql://localhost:3306/PLAYER_INFO", "root", "root@123"); 

			// Step 2.B: Creating JDBC CallableStatement 
			callableStatement = connection.prepareCall("{call spInsertNewPlayerRecord(?, ?, ?)}");

			// set values for new player record - 1
			callableStatement.setString(1, "Herschelle Gibbs");
			callableStatement.setInt(2, 42);
			callableStatement.setInt(3, 90);

			// add to batch - 1
			callableStatement.addBatch();

			// set values for new player record - 2
			callableStatement.setString(1, "Mervyn Dillon");
			callableStatement.setInt(2, 41);
			callableStatement.setInt(3, 38);

			// add to batch - 2
			callableStatement.addBatch();

			// set values for new player record - 3
			callableStatement.setString(1, "Nathan Astle");
			callableStatement.setInt(2, 44);
			callableStatement.setInt(3, 81);

			// add to batch - 3
			callableStatement.addBatch();

			// Step 2.C: Executing CallableStatement & retrieve data into result
			int[] insertCounts = callableStatement.executeBatch();

			// retrieving result and checking
			for(int result: insertCounts){
				System.out.println(result + " indicates insertion is successful");
			}
		}
		catch(SQLException sqlex){
			sqlex.printStackTrace();
		}
		finally {

			// Step 3: Closing database connection
			try {
				if(null != connection) {

					// cleanup resources, once after processing
					callableStatement.close();

					// and then finally close connection
					connection.close();
				}
			}
			catch (SQLException sqlex) {
				sqlex.printStackTrace();
			}
		}
	}
}